Index: /XIOS/branchs/xios-1.0/arch/arch-X64_ATHENA.env
===================================================================
--- /XIOS/branchs/xios-1.0/arch/arch-X64_ATHENA.env	(revision 564)
+++ /XIOS/branchs/xios-1.0/arch/arch-X64_ATHENA.env	(revision 564)
@@ -0,0 +1,15 @@
+# Environment to compile XIOS on Athena 
+#
+#   Prerequisite softwares installed with 
+#
+module load INTEL/intel_xe_2013
+module load HDF5/hdf5-1.8.11_parallel
+module load NETCDF/netcdf-4.3_parallel
+module load NETCDF/parallel-netcdf-1.3.1
+
+#export NETCDF_DIR=${NETCDF}
+#export PNETCDF_DIR=${PNETCDF}
+export NETCDF_DIR=/users/home/opt/netcdf/netcdf-4.3_parallel
+export PNETCDF_DIR=/users/home/opt/netcdf/parallel-netcdf-1.3.1
+export HDF5_DIR=/users/home/opt/hdf5/hdf5-1.8.11_parallel
+
Index: /XIOS/branchs/xios-1.0/arch/arch-X64_ATHENA.fcm
===================================================================
--- /XIOS/branchs/xios-1.0/arch/arch-X64_ATHENA.fcm	(revision 564)
+++ /XIOS/branchs/xios-1.0/arch/arch-X64_ATHENA.fcm	(revision 564)
@@ -0,0 +1,26 @@
+################################################################################
+###################        Projet xios - xmlioserver       #####################
+################################################################################
+
+%CCOMPILER      mpiicc
+%FCOMPILER      mpiifort
+%LINKER         mpiifort -nofor-main
+
+%BASE_CFLAGS    -diag-disable 1125 -diag-disable 279
+%PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
+%DEV_CFLAGS     -g -traceback
+%DEBUG_CFLAGS   -DBZ_DEBUG -g -traceback -fno-inline
+
+%BASE_FFLAGS    -D__NONE__
+%PROD_FFLAGS    -O3
+%DEV_FFLAGS     -g -O2 -traceback
+%DEBUG_FFLAGS   -g -traceback
+
+%BASE_INC       -D__NONE__
+%BASE_LD        -lstdc++ -lz -lcurl -Wl -lgpfs
+
+%CPP            mpiicc -EP
+%FPP            cpp -P
+%MAKE           gmake
+
+
Index: /XIOS/branchs/xios-1.0/arch/arch-X64_ATHENA.path
===================================================================
--- /XIOS/branchs/xios-1.0/arch/arch-X64_ATHENA.path	(revision 564)
+++ /XIOS/branchs/xios-1.0/arch/arch-X64_ATHENA.path	(revision 564)
@@ -0,0 +1,12 @@
+NETCDF_INCDIR="-I${NETCDF_DIR}/include -I${PNETCDF_DIR}/include"
+NETCDF_LIBDIR="-L${NETCDF_DIR}/lib -L${PNETCDF_DIR}/lib"
+NETCDF_LIB="-L${NETCDF_DIR}/lib -lnetcdff -L${NETCDF_DIR}/lib -lnetcdf -L${PNETCDF_DIR}/lib -lpnetcdf"
+
+HDF5_INCDIR="-I${HDF5_DIR}/include"
+HDF5_LIBDIR="-L${HDF5_DIR}/lib"
+HDF5_LIB="-L${HDF5_DIR}/lib -lhdf5_hl -L${HDF5_DIR}/lib -lhdf5"
+
+OASIS_INCDIR=""
+OASIS_LIBDIR=""
+OASIS_LIB=""
+
Index: /XIOS/trunk/arch/arch-X64_ATHENA.env
===================================================================
--- /XIOS/trunk/arch/arch-X64_ATHENA.env	(revision 564)
+++ /XIOS/trunk/arch/arch-X64_ATHENA.env	(revision 564)
@@ -0,0 +1,15 @@
+# Environment to compile XIOS on Athena 
+#
+#   Prerequisite softwares installed with 
+#
+module load INTEL/intel_xe_2013
+module load HDF5/hdf5-1.8.11_parallel
+module load NETCDF/netcdf-4.3_parallel
+module load NETCDF/parallel-netcdf-1.3.1
+
+#export NETCDF_DIR=${NETCDF}
+#export PNETCDF_DIR=${PNETCDF}
+export NETCDF_DIR=/users/home/opt/netcdf/netcdf-4.3_parallel
+export PNETCDF_DIR=/users/home/opt/netcdf/parallel-netcdf-1.3.1
+export HDF5_DIR=/users/home/opt/hdf5/hdf5-1.8.11_parallel
+
Index: /XIOS/trunk/arch/arch-X64_ATHENA.fcm
===================================================================
--- /XIOS/trunk/arch/arch-X64_ATHENA.fcm	(revision 564)
+++ /XIOS/trunk/arch/arch-X64_ATHENA.fcm	(revision 564)
@@ -0,0 +1,26 @@
+################################################################################
+###################        Projet xios - xmlioserver       #####################
+################################################################################
+
+%CCOMPILER      mpiicc
+%FCOMPILER      mpiifort
+%LINKER         mpiifort -nofor-main
+
+%BASE_CFLAGS    -diag-disable 1125 -diag-disable 279
+%PROD_CFLAGS    -O3 -D BOOST_DISABLE_ASSERTS
+%DEV_CFLAGS     -g -traceback
+%DEBUG_CFLAGS   -DBZ_DEBUG -g -traceback -fno-inline
+
+%BASE_FFLAGS    -D__NONE__
+%PROD_FFLAGS    -O3
+%DEV_FFLAGS     -g -O2 -traceback
+%DEBUG_FFLAGS   -g -traceback
+
+%BASE_INC       -D__NONE__
+%BASE_LD        -lstdc++ -lz -lcurl -Wl -lgpfs
+
+%CPP            mpiicc -EP
+%FPP            cpp -P
+%MAKE           gmake
+
+
Index: /XIOS/trunk/arch/arch-X64_ATHENA.path
===================================================================
--- /XIOS/trunk/arch/arch-X64_ATHENA.path	(revision 564)
+++ /XIOS/trunk/arch/arch-X64_ATHENA.path	(revision 564)
@@ -0,0 +1,12 @@
+NETCDF_INCDIR="-I${NETCDF_DIR}/include -I${PNETCDF_DIR}/include"
+NETCDF_LIBDIR="-L${NETCDF_DIR}/lib -L${PNETCDF_DIR}/lib"
+NETCDF_LIB="-L${NETCDF_DIR}/lib -lnetcdff -L${NETCDF_DIR}/lib -lnetcdf -L${PNETCDF_DIR}/lib -lpnetcdf"
+
+HDF5_INCDIR="-I${HDF5_DIR}/include"
+HDF5_LIBDIR="-L${HDF5_DIR}/lib"
+HDF5_LIB="-L${HDF5_DIR}/lib -lhdf5_hl -L${HDF5_DIR}/lib -lhdf5"
+
+OASIS_INCDIR=""
+OASIS_LIBDIR=""
+OASIS_LIB=""
+