Index: /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE.env
===================================================================
--- /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE.env	(revision 573)
+++ /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE.env	(revision 574)
@@ -1,4 +1,3 @@
 module unload netcdf
 module unload hdf5
-module load hdf5/1.8.9_parallel
-module load netcdf/4.2_hdf5_parallel
+module load netcdf/4.3.3.1_hdf5_parallel
Index: /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE.path
===================================================================
--- /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE.path	(revision 573)
+++ /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE.path	(revision 574)
@@ -1,4 +1,4 @@
-NETCDF_INCDIR="-I $NETCDF_INC_DIR"
-NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
+NETCDF_INCDIR="-I $NETCDF_INCDIR"
+NETCDF_LIBDIR="-L $NETCDF_LIBDIR"
 NETCDF_LIB="-lnetcdf"
 
@@ -7,7 +7,7 @@
 MPI_LIB=""
 
-HDF5_INCDIR="-I$HDF5_INC_DIR"
-HDF5_LIBDIR="-L$HDF5_LIB_DIR"
-HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
+HDF5_INCDIR=""
+HDF5_LIBDIR=""
+HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
 
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
Index: /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_GCC.env
===================================================================
--- /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_GCC.env	(revision 573)
+++ /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_GCC.env	(revision 574)
@@ -1,6 +1,6 @@
 module unload netcdf
 module unload hdf5
-module load netcdf/4.2_hdf5_parallel
-module load gnu/4.6.3  
+module load netcdf/4.3.3.1_hdf5_parallel
+module load gnu/4.9.1
 export OMPI_CC=gcc
 export OMPI_CXX=g++
Index: /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_GCC.path
===================================================================
--- /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_GCC.path	(revision 573)
+++ /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_GCC.path	(revision 574)
@@ -1,5 +1,5 @@
-NETCDF_INCDIR="-I $NETCDF_INC_DIR"
-NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
-NETCDF_LIB="-lnetcdff -lnetcdf"
+NETCDF_INCDIR="-I $NETCDF_INCDIR"
+NETCDF_LIBDIR="-L $NETCDF_LIBDIR"
+NETCDF_LIB="-lnetcdf"
 
 MPI_INCDIR=""
Index: /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_PGI.env
===================================================================
--- /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_PGI.env	(revision 573)
+++ /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_PGI.env	(revision 574)
@@ -1,10 +1,9 @@
 module unload netcdf
 module unload hdf5
-module load netcdf/4.2_hdf5_parallel
+module load netcdf/4.3.3.1_hdf5_parallel
 #module unload intel
 module unload pgi
 module unload gnu
-module load gnu/4.6.3 
-module load  pgi/12.6  
+module load pgi/14.10
 
 export OMPI_CC=pgcc
Index: /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_PGI.fcm
===================================================================
--- /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_PGI.fcm	(revision 573)
+++ /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_PGI.fcm	(revision 574)
@@ -5,5 +5,5 @@
 %CCOMPILER      mpicxx -noswitcherror
 %FCOMPILER      mpif90 -noswitcherror
-%LINKER         mpif90 -noswitcherror  
+%LINKER         mpif90 -noswitcherror
 
 %BASE_CFLAGS    -D__NONE__
Index: /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_PGI.path
===================================================================
--- /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_PGI.path	(revision 573)
+++ /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_PGI.path	(revision 574)
@@ -1,5 +1,5 @@
-NETCDF_INCDIR="-I $NETCDF_INC_DIR"
-NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
-NETCDF_LIB="-lnetcdff -lnetcdf"
+NETCDF_INCDIR="-I $NETCDF_INCDIR"
+NETCDF_LIBDIR="-L $NETCDF_LIBDIR"
+NETCDF_LIB="-lnetcdf"
 
 MPI_INCDIR=""
Index: /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_VAMPIR.env
===================================================================
--- /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_VAMPIR.env	(revision 573)
+++ /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_VAMPIR.env	(revision 574)
@@ -2,5 +2,4 @@
 module unload hdf5
 module unload vampir
-module load vampir/7.5
-module load hdf5/1.8.9_parallel
-module load netcdf/4.2_hdf5_parallel
+module load vampir/8.2.1
+module load netcdf/4.3.3.1_hdf5_parallel
Index: /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_VAMPIR.path
===================================================================
--- /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_VAMPIR.path	(revision 573)
+++ /XIOS/branchs/xios-1.0/arch/arch-X64_CURIE_VAMPIR.path	(revision 574)
@@ -1,4 +1,4 @@
-NETCDF_INCDIR="-I $NETCDF_INC_DIR"
-NETCDF_LIBDIR="-L$NETCDF_LIB_DIR"
+NETCDF_INCDIR="-I $NETCDF_INCDIR"
+NETCDF_LIBDIR="-L$NETCDF_LIBDIR"
 NETCDF_LIB="-lnetcdf"
 
@@ -7,7 +7,7 @@
 MPI_LIB=""
 
-HDF5_INCDIR="-I$HDF5_INC_DIR"
-HDF5_LIBDIR="-L$HDF5_LIB_DIR"
-HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
+HDF5_INCDIR=""
+HDF5_LIBDIR=""
+HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
 
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
Index: /XIOS/trunk/arch/arch-X64_CURIE.env
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE.env	(revision 573)
+++ /XIOS/trunk/arch/arch-X64_CURIE.env	(revision 574)
@@ -1,4 +1,3 @@
 module unload netcdf
 module unload hdf5
-module load hdf5/1.8.9_parallel
-module load netcdf/4.2_hdf5_parallel
+module load netcdf/4.3.3.1_hdf5_parallel
Index: /XIOS/trunk/arch/arch-X64_CURIE.path
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE.path	(revision 573)
+++ /XIOS/trunk/arch/arch-X64_CURIE.path	(revision 574)
@@ -1,4 +1,4 @@
-NETCDF_INCDIR="-I $NETCDF_INC_DIR"
-NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
+NETCDF_INCDIR="-I $NETCDF_INCDIR"
+NETCDF_LIBDIR="-L $NETCDF_LIBDIR"
 NETCDF_LIB="-lnetcdf"
 
@@ -7,7 +7,7 @@
 MPI_LIB=""
 
-HDF5_INCDIR="-I$HDF5_INC_DIR"
-HDF5_LIBDIR="-L$HDF5_LIB_DIR"
-HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
+HDF5_INCDIR=""
+HDF5_LIBDIR=""
+HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
 
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"
Index: /XIOS/trunk/arch/arch-X64_CURIE_GCC.env
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE_GCC.env	(revision 573)
+++ /XIOS/trunk/arch/arch-X64_CURIE_GCC.env	(revision 574)
@@ -1,6 +1,6 @@
 module unload netcdf
 module unload hdf5
-module load netcdf/4.2_hdf5_parallel
-module load gnu/4.6.3  
+module load netcdf/4.3.3.1_hdf5_parallel
+module load gnu/4.9.1
 export OMPI_CC=gcc
 export OMPI_CXX=g++
Index: /XIOS/trunk/arch/arch-X64_CURIE_GCC.path
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE_GCC.path	(revision 573)
+++ /XIOS/trunk/arch/arch-X64_CURIE_GCC.path	(revision 574)
@@ -1,5 +1,5 @@
-NETCDF_INCDIR="-I $NETCDF_INC_DIR"
-NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
-NETCDF_LIB="-lnetcdff -lnetcdf"
+NETCDF_INCDIR="-I $NETCDF_INCDIR"
+NETCDF_LIBDIR="-L $NETCDF_LIBDIR"
+NETCDF_LIB="-lnetcdf"
 
 MPI_INCDIR=""
Index: /XIOS/trunk/arch/arch-X64_CURIE_PGI.env
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE_PGI.env	(revision 573)
+++ /XIOS/trunk/arch/arch-X64_CURIE_PGI.env	(revision 574)
@@ -1,10 +1,9 @@
 module unload netcdf
 module unload hdf5
-module load netcdf/4.2_hdf5_parallel
+module load netcdf/4.3.3.1_hdf5_parallel
 #module unload intel
 module unload pgi
 module unload gnu
-module load gnu/4.6.3 
-module load  pgi/12.6  
+module load pgi/14.10
 
 export OMPI_CC=pgcc
Index: /XIOS/trunk/arch/arch-X64_CURIE_PGI.fcm
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE_PGI.fcm	(revision 573)
+++ /XIOS/trunk/arch/arch-X64_CURIE_PGI.fcm	(revision 574)
@@ -5,5 +5,5 @@
 %CCOMPILER      mpicxx -noswitcherror
 %FCOMPILER      mpif90 -noswitcherror
-%LINKER         mpif90 -noswitcherror  
+%LINKER         mpif90 -noswitcherror
 
 %BASE_CFLAGS    -D__NONE__
Index: /XIOS/trunk/arch/arch-X64_CURIE_PGI.path
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE_PGI.path	(revision 573)
+++ /XIOS/trunk/arch/arch-X64_CURIE_PGI.path	(revision 574)
@@ -1,5 +1,5 @@
-NETCDF_INCDIR="-I $NETCDF_INC_DIR"
-NETCDF_LIBDIR="-L $NETCDF_LIB_DIR"
-NETCDF_LIB="-lnetcdff -lnetcdf"
+NETCDF_INCDIR="-I $NETCDF_INCDIR"
+NETCDF_LIBDIR="-L $NETCDF_LIBDIR"
+NETCDF_LIB="-lnetcdf"
 
 MPI_INCDIR=""
Index: /XIOS/trunk/arch/arch-X64_CURIE_VAMPIR.env
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE_VAMPIR.env	(revision 573)
+++ /XIOS/trunk/arch/arch-X64_CURIE_VAMPIR.env	(revision 574)
@@ -2,5 +2,4 @@
 module unload hdf5
 module unload vampir
-module load vampir/7.5
-module load hdf5/1.8.9_parallel
-module load netcdf/4.2_hdf5_parallel
+module load vampir/8.2.1
+module load netcdf/4.3.3.1_hdf5_parallel
Index: /XIOS/trunk/arch/arch-X64_CURIE_VAMPIR.path
===================================================================
--- /XIOS/trunk/arch/arch-X64_CURIE_VAMPIR.path	(revision 573)
+++ /XIOS/trunk/arch/arch-X64_CURIE_VAMPIR.path	(revision 574)
@@ -1,4 +1,4 @@
-NETCDF_INCDIR="-I $NETCDF_INC_DIR"
-NETCDF_LIBDIR="-L$NETCDF_LIB_DIR"
+NETCDF_INCDIR="-I $NETCDF_INCDIR"
+NETCDF_LIBDIR="-L$NETCDF_LIBDIR"
 NETCDF_LIB="-lnetcdf"
 
@@ -7,7 +7,7 @@
 MPI_LIB=""
 
-HDF5_INCDIR="-I$HDF5_INC_DIR"
-HDF5_LIBDIR="-L$HDF5_LIB_DIR"
-HDF5_LIB="-lhdf5_hl -lhdf5 -lhdf5 -lz -lcurl"
+HDF5_INCDIR=""
+HDF5_LIBDIR=""
+HDF5_LIB="-lhdf5_hl -lhdf5 -lz -lcurl"
 
 OASIS_INCDIR="-I$PWD/../../oasis3-mct/BLD/build/lib/psmile.MPI1"