Index: XIOS/branchs/xios-1.0/src/duration.cpp
===================================================================
--- XIOS/branchs/xios-1.0/src/duration.cpp	(revision 578)
+++ XIOS/branchs/xios-1.0/src/duration.cpp	(revision 579)
@@ -20,7 +20,7 @@
       CDuration & CDuration::operator=(const CDuration & duration)
       {
-         year = duration.year;  month  = duration.month ; day    = duration.day;
-         hour = duration.hour;  minute = duration.minute; second = duration.second; timestep=duration.timestep ;
-         return (*this);
+         year = duration.year;  month  = duration.month;  day    = duration.day;
+         hour = duration.hour;  minute = duration.minute; second = duration.second; timestep=duration.timestep;
+         return *this;
       }
 
@@ -29,15 +29,15 @@
          StdOStringStream sout;
          bool testValue = true;
-         if(duration.year   != 0.0) { testValue = false; sout << duration.year   << "y " ; }
+         if(duration.year   != 0.0) { testValue = false; sout << duration.year   << "y "; }
          if(duration.month  != 0.0) { testValue = false; sout << duration.month  << "mo "; }
-         if(duration.day    != 0.0) { testValue = false; sout << duration.day    << "d " ; }
-         if(duration.hour   != 0.0) { testValue = false; sout << duration.hour   << "h " ; }
+         if(duration.day    != 0.0) { testValue = false; sout << duration.day    << "d "; }
+         if(duration.hour   != 0.0) { testValue = false; sout << duration.hour   << "h "; }
          if(duration.minute != 0.0) { testValue = false; sout << duration.minute << "mi "; }
-         if(duration.second != 0.0) { testValue = false; sout << duration.second << "s " ; }
-         if(duration.timestep != 0.0 || testValue)       { sout << duration.timestep << "ts " ; }
+         if(duration.second != 0.0) { testValue = false; sout << duration.second << "s "; }
+         if(duration.timestep != 0.0 || testValue)       { sout << duration.timestep << "ts "; }
 
          // << suppression de l'espace en fin de chaÃ®ne.
          out << (sout.str().substr(0, sout.str().size()-1));
-         return (out);
+         return out;
       }
 
@@ -50,13 +50,13 @@
          while (!in.eof())
          {
-               if (!(in >> v >> c)) 
+               if (!(in >> v >> c))
                {
-                 //DEBUG("----> Pb StdIStream & operator>>(StdIStream & in , CDuration & duration)") ;
-                 //if (in.eof())  DEBUG("----> Fin de fichier StdIStream & operator>>(StdIStream & in , CDuration & duration)") ;
+                 //DEBUG("----> Pb StdIStream & operator>>(StdIStream & in , CDuration & duration)");
+                 //if (in.eof())  DEBUG("----> Fin de fichier StdIStream & operator>>(StdIStream & in , CDuration & duration)");
                }
-               if (in.eof())  
+               if (in.eof())
                {
-                 //DEBUG("----> Fin de fichier StdIStream & operator>>(StdIStream & in , CDuration & duration)") ;
-                 break ;
+                 //DEBUG("----> Fin de fichier StdIStream & operator>>(StdIStream & in , CDuration & duration)");
+                 break;
                }
                switch (c)
@@ -82,8 +82,8 @@
                   {
                     in >> c;
-                    if (c=='s') duration.timestep = v; 
+                    if (c=='s') duration.timestep = v;
                     break;
                   }
-                  
+
                   default:
                      StdString valc; valc.append(1, c);
@@ -92,5 +92,5 @@
                }
             }
-            return (in);
+            return in;
       }
 
@@ -101,6 +101,6 @@
          if ((year == 0) && (month  == 0) && (day    == 0) &&
              (hour == 0) && (minute == 0) && (second == 0) && (timestep == 0))
-            return (true);
-         return (false);
+            return true;
+         return false;
       }
 
@@ -108,16 +108,15 @@
       CDuration & CDuration::solveTimeStep(const CCalendar & c)
       {
-        CDuration timeStep=c.getTimeStep() ;
-        second +=timestep*timeStep.second ; 
-        minute +=timestep*timeStep.minute ; 
-        hour +=timestep*timeStep.hour ; 
-        day +=timestep*timeStep.day ; 
-        month +=timestep*timeStep.month ; 
-        year +=timestep*timeStep.year ; 
-        timestep = 0 ;
+        CDuration timeStep=c.getTimeStep();
+        second +=timestep*timeStep.second;
+        minute +=timestep*timeStep.minute;
+        hour +=timestep*timeStep.hour;
+        day +=timestep*timeStep.day;
+        month +=timestep*timeStep.month;
+        year +=timestep*timeStep.year;
+        timestep = 0;
+        return *this;
+      }
 
-      }
-               
-        
       CDuration & CDuration::resolve(const CCalendar & c)
       {
@@ -139,5 +138,5 @@
          month  += modf(year, &year) * (float)c.getYearLength();
          year   += int(month) /c.getYearLength(); month  = int(month)%c.getYearLength();
-         return (*this);
+         return *this;
       }
 
@@ -148,5 +147,5 @@
          const  CDuration & own = *this;
          StdOStringStream oss; oss << own;
-         return (oss.str());
+         return oss.str();
       }
 
@@ -155,10 +154,8 @@
          CDuration dr = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
          StdIStringStream iss(str); iss >> dr;
-         return (dr);
+         return dr;
       }
 
       ///---------------------------------------------------------------
-
-
 } // namespace xios
 